#ifndef _INASH_H_
#define _INASH_H_

#ifdef SHELL
# include <stdio.h>
# include <stdlib.h>
# include "output.h"

# ifndef IN_INASH_C
#  define exit exit_inash
#  define atexit atexit_inash

#  define fopen fopen_inash
#  define fclose fclose_inash
#  define fflush fflush_inash

#  define fputc fputc_inash
#  undef putc
#  define putc fputc_inash
#  undef putchar
#  define putchar(c) fputc_inash(c,stdout)

#  define fputs fputs_inash
#  define puts puts_inash
#  define fprintf fprintf_inash
#  define printf printf_inash

#  define fgetc fgetc_inash
#  undef getc
#  define getc fgetc_inash
#  undef getchar
#  define getchar getchar_inash

#  define fgets fgets_inash
#  define gets gets_inash
# endif /*IN_INASH_C*/
  typedef int mainfunc(int argc,char *argv[]);
  extern int start_inash(void);
  extern int origmain_inash(mainfunc *origmain, int argc, char *argv[]);
  extern int end_inash(void);
  extern void exit_inash(int r);
  extern void atexit_inash(void (*func)(void));
  
  extern FILE *fopen_inash(const char *file, const char *mode);
  extern int fclose_inash(FILE *fp);
  extern int fcloseall_inash(void);
  extern int fflush_inash(FILE *fp);

  extern int fputc_inash(int ch, FILE *fp);
  extern int fputs_inash(const char *s, FILE *fp);
  extern int puts_inash(const char *s);
  extern int fprintf_inash(FILE *fd, const char *format, ...);
  extern int printf_inash(const char *format, ...);
  
  extern int fgetc_inash(FILE *fp);
  extern int getchar_inash();
  extern char *fgets(char *buf, int n, FILE *fp);
  extern char *gets(char *buf);

#else /*not SHELL*/
# include <stdio.h>
# include <stdlib.h>
# undef main
#endif /*not SHELL*/

#endif /*not _INASH_H_*/
